from typing import Sequence, Dict, Optional, Union

class KS:
    from pandas import DataFrame
    from numpy import ndarray
    def __init__(self, x:Optional[Union[ndarray|DataFrame]], rset:Optional[Union[float|int]]):
        from kennard_stone import train_test_split
        self.x = x
        self.ratio = rset
        self._train, self._test = train_test_split(self.x, train_size = self.ratio)
    
    @property
    def calset(self):
        clu = self._train.index.tolist()
        return self.x, clu
    
class RDM:
    from pandas import DataFrame
    from numpy import ndarray
    def __init__(self, x:Optional[Union[ndarray|DataFrame]], rset:Optional[Union[float|int]]):
        from sklearn.model_selection import train_test_split
        self.x = x
        self.ratio = rset
        self._train, self._test = train_test_split(self.x, train_size = self.ratio)
    
    @property
    def calset(self):
        clu = self._train.index.tolist()
        
        return self.x, clu